setwd("G:/BaiduSyncdisk/Long, Peng, Yang,2024 GDP/code and data")
library(quantreg)

Dat=read.table("GDP.txt",head=T)
n=length(Dat$GDP)


tau0 = seq(0.05,0.95,by=0.01)

m=length(tau0)
B=10000

GDP_est=rep(NA,m)
NFCI_est=rep(NA,m)
GDP_est_lag=rep(NA,m)
NFCI_est_lag=rep(NA,m)
K=5;#lags
AR1=matrix(NA,nrow=K+1,ncol=m) 
GDP_pvalue=matrix(NA,nrow=5,ncol=m)
NFCI_pvalue=GDP_pvalue
GDP_pvalue_lag=GDP_pvalue
NFCI_pvalue_lag=GDP_pvalue

AR1_pvalue=matrix(NA,nrow=K+1,ncol=m)

################Model 1
################Model 1
################Model 1
################Model 1

yy=Dat$GDP[2:n]
xx1=Dat$GDP[1:(n-1)]
xx2=Dat$NFCI[1:(n-1)]; 
nn=length(yy)
delta=matrix(rexp(B*nn),nrow=B)
for(i in 1:m){
model <- rq( yy~xx1+xx2, tau = tau0[i],ci=FALSE)
tmp1=summary(model,se="boot", bsmethod= "xy")$coefficients[,4]
GDP_pvalue[1,i]=tmp1[2]
NFCI_pvalue[1,i]=tmp1[3]

tmp2=summary(model,se="boot", bsmethod= "pxy")$coefficients[,4]
GDP_pvalue[2,i]=tmp2[2]
NFCI_pvalue[2,i]=tmp2[3]

tmp3=summary(model,se="boot", bsmethod= "mcmb")$coefficients[,4]
GDP_pvalue[3,i]=tmp3[2]
NFCI_pvalue[3,i]=tmp3[3]

tmp4=summary(model,se="boot", bsmethod= "wxy")$coefficients[,4]
GDP_pvalue[4,i]=tmp4[2]
NFCI_pvalue[4,i]=tmp4[3]


tmp5=summary(model,se="boot", bsmethod= "wild")$coefficients[,4]
GDP_pvalue[5,i]=tmp5[2]
NFCI_pvalue[5,i]=tmp5[3]


GDP_est[i]=model$coefficient[2]
NFCI_est[i]=model$coefficient[3]

Resi=residuals(model)
tmp_resi=tau0[i]-(Resi<0)
for(k in 1:K){
  mu=mean(Resi[-c(1:k)])
AR1[k,i]=mean((Resi[-c(1:k)]*0-mu*0+tmp_resi[-c(1:k)])*(Resi[-c(nn-1:k)]*0-mu*0+tmp_resi[-c(nn-1:k)]))
  }
GDP_est_boot=rep(NA,B)
NFCI_est_boot=rep(NA,B)
GDP_est_lag_boot=rep(NA,B)
NFCI_est_lag_boot=rep(NA,B)
AR1_boot=matrix(NA,nrow=K+1,ncol=B)
for(b in 1:B){
  model_boot <- rq( yy~xx1+xx2, tau = tau0[i],ci=FALSE,weights=delta[b,])
  GDP_est_boot[b]=model_boot$coefficients[2]
  NFCI_est_boot[b]=model_boot$coefficients[3]

  Resi_boot=residuals(model_boot)
  tmp_resi_boot=tau0[i]-(Resi_boot<0)
  
  for(k in 1:K){
 
    mu_boot=sum(delta[b,-c(1:k)]*Resi_boot[-c(1:k)])/sum(delta[b,-c(1:k)])
    AR1_boot[k,b]=sum(delta[b,-c(1:k)]*(Resi_boot[-c(1:k)]*0-mu_boot*0+tmp_resi_boot[-c(1:k)])*(Resi_boot[-c(nn-1:k)]*0-mu_boot*0+tmp_resi_boot[-c(nn-1:k)]))/sum(delta[b,-c(1:k)])
  }
  }


#GDP_pvalue[2,i]=mean(abs(GDP_est[i])<abs(GDP_est_boot-GDP_est[i]))
#NFCI_pvalue[2,i]=mean(abs(NFCI_est[i])<abs(NFCI_est_boot-NFCI_est[i]))


for(k in 1:K){

AR1_pvalue[k,i]=mean(abs(AR1[k,i])<abs(AR1_boot[k,]-AR1[k,i]))
}
AR1_pvalue[K+1,i]=min(AR1_pvalue[1:K,i])



print(tau0[i])
print(cbind(GDP_pvalue[,i],NFCI_pvalue[,i],GDP_pvalue_lag[,i],NFCI_pvalue_lag[,i]))
print(AR1_pvalue[,i])
 
}
  pdf("GDP_pvalue_case1.pdf")
  plot(tau0,GDP_pvalue[1,],xlab="tau",ylab="Pvalue",ylim=c(min(GDP_pvalue,0.05)-0.01,max(GDP_pvalue,0.1))+0.01,main="GDP",type="l",lty=1)
  lines(tau0,GDP_pvalue[2,],lty=2,col=2)
  lines(tau0,GDP_pvalue[3,],lty=3,col=3)
  lines(tau0,GDP_pvalue[4,],lty=4,col=4)
  lines(tau0,GDP_pvalue[5,],lty=5,col=5)
  lines(tau0,0.1+0*tau0,lty=3)
  lines(tau0,0.05+0*tau0,lty=3)
  legend(0.78,0.22,c("xy","pxy","mcmb","wxy","wild"),lty=1:5,col=1:5)
  dev.off()
  pdf("NFCI_pvalue_case1.pdf")
  plot(tau0,NFCI_pvalue[1,],xlab="tau",ylab="Pvalue",ylim=c(min(NFCI_pvalue,0.05)-0.01,max(NFCI_pvalue,0.1))+0.01,main="NFCI",type="l",lty=1)
  lines(tau0,NFCI_pvalue[2,],lty=2,col=2)
  lines(tau0,NFCI_pvalue[3,],lty=3,col=3)
  lines(tau0,NFCI_pvalue[4,],lty=4,col=4)
  lines(tau0,NFCI_pvalue[5,],lty=5,col=5)
  lines(tau0,0.1+0*tau0,lty=3)
  lines(tau0,0.05+0*tau0,lty=3)
  legend(0.2,0.8,c("xy","pxy","mcmb","wxy","wild"),lty=1:5,col=1:5)
  dev.off()
  pdf("AR1_pvalue_case1.pdf")
  plot(tau0,AR1_pvalue[K+1,],xlab="tau",ylab="Pvalue",ylim=c(min(AR1_pvalue[K+1,],0.05)-0.01,max(AR1_pvalue[K+1,],0.1)+0.01),main="Residuals",type="l",lty=1)
  lines(tau0,0.1+0*tau0,lty=3)
  lines(tau0,0.05+0*tau0,lty=3)
  dev.off()
  save.image("Case1.Rdata")


################Model 4 for figure 4
################Model 4 for figure 4
################Model 4 for figure 4




  yy=Dat$GDP[3:n]

  xx1=Dat$GDP[2:(n-1)];
  xx2=Dat$NFCI[2:(n-1)];

  xx3=Dat$GDP[1:(n-2)]
  xx4=Dat$NFCI[1:(n-2)]; 

  nn=length(yy)
  delta=matrix(rexp(B*nn),nrow=B)
  for(i in 1:m){   ####1:m
    model <- rq( yy~xx1+xx2+xx3+xx4, tau = tau0[i],ci=FALSE)
    
 tmp1=summary(model,se="boot", bsmethod= "xy")$coefficients[,4]
GDP_pvalue[1,i]=tmp1[2]
NFCI_pvalue[1,i]=tmp1[3]
GDP_pvalue_lag[1,i]=tmp1[4]
NFCI_pvalue_lag[1,i]=tmp1[5]

tmp2=summary(model,se="boot", bsmethod= "pxy")$coefficients[,4]
GDP_pvalue[2,i]=tmp2[2]
NFCI_pvalue[2,i]=tmp2[3]
GDP_pvalue_lag[2,i]=tmp2[4]
NFCI_pvalue_lag[2,i]=tmp2[5]

tmp3=summary(model,se="boot", bsmethod= "mcmb")$coefficients[,4]
GDP_pvalue[3,i]=tmp3[2]
NFCI_pvalue[3,i]=tmp3[3]
GDP_pvalue_lag[3,i]=tmp3[4]
NFCI_pvalue_lag[3,i]=tmp3[5]

tmp4=summary(model,se="boot", bsmethod= "wxy")$coefficients[,4]
GDP_pvalue[4,i]=tmp4[2]
NFCI_pvalue[4,i]=tmp4[3]
GDP_pvalue_lag[4,i]=tmp4[4]
NFCI_pvalue_lag[4,i]=tmp4[5]


tmp5=summary(model,se="boot", bsmethod= "wild")$coefficients[,4]
GDP_pvalue[5,i]=tmp5[2]
NFCI_pvalue[5,i]=tmp5[3]
GDP_pvalue_lag[5,i]=tmp5[4]
NFCI_pvalue_lag[5,i]=tmp5[5]



    
    GDP_est[i]=model$coefficient[2]
    NFCI_est[i]=model$coefficient[3]
    GDP_est_lag[i]=model$coefficient[4]
    NFCI_est_lag[i]=model$coefficients[5]
    Resi=residuals(model)
    tmp_resi=tau0[i]-(Resi<0)
    for(k in 1:K){ 
      mu=mean(Resi[-c(1:k)])
      AR1[k,i]=mean((Resi[-c(1:k)]*0-mu*0+tmp_resi[-c(1:k)])*(Resi[-c(nn-1:k)]*0-mu*0+tmp_resi[-c(nn-1:k)]))
    }
    GDP_est_boot=rep(NA,B)
    NFCI_est_boot=rep(NA,B)
    GDP_est_lag_boot=rep(NA,B)
    NFCI_est_lag_boot=rep(NA,B)
    AR1_boot=matrix(NA,nrow=K+1,ncol=B)
    for(b in 1:B){ #####B
      model_boot <- rq( yy~xx1+xx2+xx3+xx4, tau = tau0[i],ci=FALSE,weights=delta[b,])
      GDP_est_boot[b]=model_boot$coefficients[2]
      NFCI_est_boot[b]=model_boot$coefficients[3]
      GDP_est_lag_boot[b]=model_boot$coefficients[4]
      NFCI_est_lag_boot[b]=model_boot$coefficients[5]
      Resi_boot=residuals(model_boot)
      tmp_resi_boot=tau0[i]-(Resi_boot<0)
      
      for(k in 1:K){
        mu_boot=sum(delta[b,-c(1:k)]*Resi_boot[-c(1:k)])/sum(delta[b,-c(1:k)])
        AR1_boot[k,b]=sum(delta[b,-c(1:k)]*(Resi_boot[-c(1:k)]*0-mu_boot*0+tmp_resi_boot[-c(1:k)])*(Resi_boot[-c(nn-1:k)]*0-mu_boot*0+tmp_resi_boot[-c(nn-1:k)]))/sum(delta[b,-c(1:k)])
                   }
    }            ###B end
    
    
    ###
#    GDP_pvalue[2,i]=mean(abs(GDP_est[i])<abs(GDP_est_boot-GDP_est[i]))
#    NFCI_pvalue[2,i]=mean(abs(NFCI_est[i])<abs(NFCI_est_boot-NFCI_est[i]))
#    GDP_pvalue_lag[2,i]=mean(abs(GDP_est_lag[i])<abs(GDP_est_lag_boot-GDP_est_lag[i]))
#    NFCI_pvalue_lag[2,i]=mean(abs(NFCI_est_lag[i])<abs(NFCI_est_lag_boot-NFCI_est_lag[i]))
    ###
    
    for(k in 1:K){
      AR1_pvalue[k,i]=mean(abs(AR1[k,i])<abs(AR1_boot[k,]-AR1[k,i]))
    }
    AR1_pvalue[K+1,i]=min(AR1_pvalue[1:K,i])
    
    
    
   print(tau0[i])
   print(cbind(GDP_pvalue[,i],NFCI_pvalue[,i],GDP_pvalue_lag[,i],NFCI_pvalue_lag[,i]))
   print(AR1_pvalue[,i])
    
  
  }          ########m  end

  pdf("GDP_pvalue_Model4.pdf")
  plot(tau0,GDP_pvalue[1,],xlab="tau",ylab="Pvalue",ylim=c(min(GDP_pvalue,0.05)-0.01,max(GDP_pvalue,0.1))+0.01,main="GDP",type="l",lty=1)
  lines(tau0,GDP_pvalue[2,],lty=2,col=2)
  lines(tau0,GDP_pvalue[3,],lty=3,col=3)
  lines(tau0,GDP_pvalue[4,],lty=4,col=4)
  lines(tau0,GDP_pvalue[5,],lty=5,col=5)
  lines(tau0,0.1+0*tau0,lty=3)
  lines(tau0,0.05+0*tau0,lty=3)
  legend(0.6,0.4,c("xy","pxy","mcmb","wxy","wild"),lty=1:5,col=1:5)
  dev.off()

  pdf("NFCI_pvalue_Model4.pdf")
  plot(tau0,NFCI_pvalue[1,],xlab="tau",ylab="Pvalue",ylim=c(min(NFCI_pvalue,0.05)-0.01,max(NFCI_pvalue,0.1))+0.01,main="NFCI",type="l",lty=1)
  lines(tau0,NFCI_pvalue[2,],lty=2,col=2)
  lines(tau0,NFCI_pvalue[3,],lty=3,col=3)
  lines(tau0,NFCI_pvalue[4,],lty=4,col=4)
  lines(tau0,NFCI_pvalue[5,],lty=5,col=5)
  lines(tau0,0.1+0*tau0,lty=3)
  lines(tau0,0.05+0*tau0,lty=3)
  legend(0.2,0.8,c("xy","pxy","mcmb","wxy","wild"),lty=1:5,col=1:5)
  dev.off()


  pdf("GDP_pvalue_lag_Model4.pdf")
  plot(tau0,GDP_pvalue_lag[1,],xlab="tau",ylab="Pvalue",ylim=c(min(GDP_pvalue,0.05)-0.01,max(GDP_pvalue_lag,0.1))+0.01,main="GDP",type="l",lty=1)
  lines(tau0,GDP_pvalue_lag[2,],lty=2,col=2)
  lines(tau0,GDP_pvalue_lag[3,],lty=3,col=3)
  lines(tau0,GDP_pvalue_lag[4,],lty=4,col=4)
  lines(tau0,GDP_pvalue_lag[5,],lty=5,col=5)
  lines(tau0,0.1+0*tau0,lty=3)
  lines(tau0,0.05+0*tau0,lty=3)
  legend(0.45,0.8,c("xy","pxy","mcmb","wxy","wild"),lty=1:5,col=1:5)
  dev.off()

  pdf("NFCI_pvalue_lag_Model4.pdf")
  plot(tau0,NFCI_pvalue_lag[1,],xlab="tau",ylab="Pvalue",ylim=c(min(NFCI_pvalue,0.05)-0.01,max(NFCI_pvalue_lag,0.1))+0.01,main="NFCI",type="l",lty=1)
  lines(tau0,NFCI_pvalue_lag[2,],lty=2,col=2)
  lines(tau0,NFCI_pvalue_lag[3,],lty=3,col=3)
  lines(tau0,NFCI_pvalue_lag[4,],lty=4,col=4)
  lines(tau0,NFCI_pvalue_lag[5,],lty=5,col=5)
  lines(tau0,0.1+0*tau0,lty=3)
  lines(tau0,0.05+0*tau0,lty=3)
  legend(0.5,0.8,c("xy","pxy","mcmb","wxy","wild"),lty=1:5,col=1:5)
  dev.off()





  pdf("AR1_pvalue_case2.pdf")
  plot(tau0,AR1_pvalue[K+1,],xlab="tau",ylab="Pvalue",ylim=c(min(AR1_pvalue[K+1,],0.05)-0.01,max(AR1_pvalue[K+1,],0.1)+0.01),main="Residuals",type="l",lty=1)
  lines(tau0,0.1+0*tau0,lty=3)
  lines(tau0,0.05+0*tau0,lty=3)
  dev.off()
  save.image("Case2.Rdata")


