
setwd("G:/BaiduSyncdisk/Long, Peng, Yang,2024 GDP/code and data")

library(quantreg)
require(mvtnorm)
# read functions
source("hac_qr_fn.R")
# Load data


Dat=read.table("GDP_annually.txt",head=T)
n=length(Dat$GDP)
#############Model 1
#############Model 1
#############Model 1
#############Model 1
#############Model 1
#############Model 1
#############Model 1
#############Model 1

yy=Dat$GDPannually[2:n]
xx1=Dat$GDP[1:(n-1)]
xx2=Dat$NFCI[1:(n-1)]; 
nn=length(yy)

# 1. Robust Inference - preparation
taus <- seq(0.05,0.95,by=0.01)	# quantiles levels to be estimated
ker  <- 3			# 1 truncated kernel, 2 Bartlett kernel, 3 QS kernel
M=length(taus)
p1values=rep(0,M)
p2values=rep(0,M)

for(k in 1:M){ # loop for each tau
tt<-taus[k]

# 2. Regressions

#QR and OLS regression with standard inference 
qreg <- rq(yy ~ xx1 + xx2,tau=tt)

uhat <- qreg$resid

# 3. Bandwidth
	h = (tt - I(uhat<0))
	x.ext = cbind(1,xx1,xx2)
	p = ncol(x.ext)
	H2 = (h %o% rep(1,p))*x.ext
	st = band(H2,nn,ng=1,dy=p,ker)$band



# 4. HAC estimators
    bb  <- summary(qreg,se="nid",covariance=TRUE)
    bb3 <- hac.se(x.ext,(tt*(1-tt)*bb$J),bb$Hinv,uhat,tau=tt,nn,mt=st,ker) # estimated (optimal) bandwidth
	t1 <- qreg$coefficients[2]/sqrt(diag(bb3$cov))[2]
      	t2 <- qreg$coefficients[3]/sqrt(diag(bb3$cov))[3]
p1values[k]=2*(1-pnorm(abs(t1)))
p2values[k]=2*(1-pnorm(abs(t2)))

} # end of the loop

  pdf("annuallyGDP_pvalue_HAC_Model1.pdf")
plot(taus,p1values,xlab="tau",ylab="Pvalue",main="GDP",type="l",lty=1)
  lines(taus,0.1+0*taus,lty=3)
  lines(taus,0.05+0*taus,lty=3)

  dev.off()
  pdf("annuallyNFCI_pvalue_HAC_Model1.pdf")
plot(taus,p2values,xlab="tau",ylab="Pvalue",main="NFCI",type="l",lty=1)
  lines(taus,0.1+0*taus,lty=3)
  lines(taus,0.05+0*taus,lty=3)

  dev.off()







#############Model 4
#############Model 4
#############Model 4
#############Model 4
#############Model 4
#############Model 4
#############Model 4
#############Model 4


  yy=Dat$GDPannually[3:n]
  yy1=Dat$GDPannually[2:(n-1)]
  yy2=Dat$GDPannually[1:(n-2)]
  xx3=Dat$GDP[1:(n-2)]
  xx4=Dat$NFCI[1:(n-2)]; 
  xx1=Dat$GDP[2:(n-1)];
  xx2=Dat$NFCI[2:(n-1)];
  nn=length(yy)

# 1. Robust Inference - preparation
taus <- seq(0.05,0.95,by=0.01)	# quantiles levels to be estimated
ker  <- 3			# 1 truncated kernel, 2 Bartlett kernel, 3 QS kernel
M=length(taus)
p1values=rep(0,M)
p2values=rep(0,M)
p3values=rep(0,M)
p4values=rep(0,M)

for(k in 1:M){ # loop for each tau
tt<-taus[k]

# 2. Regressions

#QR and OLS regression with standard inference 
qreg <- rq(yy ~ xx1 + xx2+xx3 + xx4+yy1+yy2,tau=tt)

uhat <- qreg$resid

# 3. Bandwidth
	h = (tt - I(uhat<0))
	x.ext = cbind(1,xx1,xx2,xx3,xx4,yy1,yy2)
	p = ncol(x.ext)
	H2 = (h %o% rep(1,p))*x.ext
	st = band(H2,nn,ng=1,dy=p,ker)$band



# 4. HAC estimators
    bb  <- summary(qreg,se="nid",covariance=TRUE)
    bb3 <- hac.se(x.ext,(tt*(1-tt)*bb$J),bb$Hinv,uhat,tau=tt,nn,mt=st,ker) # estimated (optimal) bandwidth
	t1 <- qreg$coefficients[2]/sqrt(diag(bb3$cov))[2]
      	t2 <- qreg$coefficients[3]/sqrt(diag(bb3$cov))[3]
	t3 <- qreg$coefficients[4]/sqrt(diag(bb3$cov))[4]
      	t4 <- qreg$coefficients[5]/sqrt(diag(bb3$cov))[5]
p1values[k]=2*(1-pnorm(abs(t1)))
p2values[k]=2*(1-pnorm(abs(t2)))
p3values[k]=2*(1-pnorm(abs(t3)))
p4values[k]=2*(1-pnorm(abs(t4)))

} # end of the loop

  dev.off()

  pdf("annuallyGDP_pvalue_HAC_Model4.pdf")
plot(taus,p1values,xlab="tau",ylab="Pvalue",main="GDP",type="l",lty=1)
  lines(taus,0.1+0*taus,lty=3)
  lines(taus,0.05+0*taus,lty=3)

  dev.off()

  pdf("annuallyNFCI_pvalue_HAC_Model4.pdf")
plot(taus,p2values,xlab="tau",ylab="Pvalue",main="NFCI",type="l",lty=1)
  lines(taus,0.1+0*taus,lty=3)
  lines(taus,0.05+0*taus,lty=3)

  dev.off()

  pdf("annuallyGDP_lag2_pvalue_HAC_Model4.pdf")
plot(taus,p3values,xlab="tau",ylab="Pvalue",main="GDP",type="l",lty=1)
  lines(taus,0.1+0*taus,lty=3)
  lines(taus,0.05+0*taus,lty=3)

  dev.off()

  pdf("annuallyNFCI_lag2_pvalue_HAC_Model4.pdf")
plot(taus,p4values,xlab="tau",ylab="Pvalue",main="NFCI",type="l",lty=1)
  lines(taus,0.1+0*taus,lty=3)
  lines(taus,0.05+0*taus,lty=3)

  dev.off()




