library(sandwich)
library(lmtest)
library(quantreg)
library(MASS)




###########this is for joint test


########################## beta_est_rwb function begin

beta_est_rwb=function(tau0,y1,x1,yy,delta){
 
model <- rq( yy~y1+x1, tau = tau0,ci=FALSE,weights=delta)

          
return(model$coefficients[2:3])

                             }
########################## beta_est_rwb function end

#################

#################data generate process 

data=function(beta,pi0,T){

x=rnorm(T)
for(t in 2:T){x[t]=pi0*x[t-1]+rnorm(1)}
u=rnorm(T)
y=rep(0,T)
y[1]=u[1]
for(t in 2:T){y[t]=beta[1]*y[t-1]+beta[2]*x[t-1]+u[t]}

return(cbind(y[1:(T-1)],x[1:(T-1)],y[2:T]))

               }
#################data generate process end



##############power function 
power=function(beta,pi0,tau0,T,B, rep){

count1=0



for(k in 1:rep)      { 
data1=data(beta,pi0,T)
y1=data1[,1]
x1=data1[,2]
yy=data1[,3]


model <- rq( yy~y1+x1, tau = tau0,ci=FALSE)
beta_hat=model$coefficients[2:3]



#####use rwb with delta=rexp(T)
beta_boot=rep(0,B*2)
dim(beta_boot)=c(B,2)


for(b in 1:B){
delta=rexp(T-1)
beta_boot[b,]=beta_est_rwb(tau0,y1,x1,yy,delta)
              }
#####calculate p value
count0=0
for(b in 1:B){
left=sum(beta_hat^2)
right= (beta_boot[b,1]-beta_hat[1])^2+(beta_boot[b,2]-beta_hat[2])^2

if( left<right  ){count0=count0+1}
              }
pvalue=count0/B
#####calculate p value end

if(pvalue<0.05){count1=count1+1}



                     }

return(count1/rep)


                    }

##############power function end



###size

power(beta=c(0,0),pi0=0.88,tau0=0.1,T=100,B=399, rep=10000)

power(beta=c(0,0),pi0=0,tau0=0.1,T=100,B=399, rep=10000)



power(beta=c(0.5,0),pi0=0.88,tau0=0.1,T=100,B=399, rep=1000)


power(beta=c(0,0.5),pi0=0.88,tau0=0.1,T=100,B=399, rep=1000)


power(beta=c(0.5,0.5),pi0=0.88,tau0=0.1,T=100,B=399, rep=1000)









